poj 2488 A Knight's Journey (DFS)

A Knight's Journey
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 34660 Accepted: 11827

Description

Background 
The knight is getting bored of seeing the same black and white squares again and again and has decided to make a journey 
around the world. Whenever a knight moves, it is two squares in one direction and one square perpendicular to this. The world of a knight is the chessboard he is living on. Our knight lives on a chessboard that has a smaller area than a regular 8 * 8 board, but it is still rectangular. Can you help this adventurous knight to make travel plans? 

Problem 
Find a path such that the knight visits every square once. The knight can start and end on any square of the board.

Input

The input begins with a positive integer n in the first line. The following lines contain n test cases. Each test case consists of a single line with two positive integers p and q, such that 1 <= p * q <= 26. This represents a p * q chessboard, where p describes how many different square numbers 1, . . . , p exist, q describes how many different square letters exist. These are the first q letters of the Latin alphabet: A, . . .

Output

The output for every scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1. Then print a single line containing the lexicographically first path that visits all squares of the chessboard with knight moves followed by an empty line. The path should be given on a single line by concatenating the names of the visited squares. Each square name consists of a capital letter followed by a number. 
If no such path exist, you should output impossible on a single line.

Sample Input

3
1 1
2 3
4 3

Sample Output

Scenario #1:
A1

Scenario #2:
impossible

Scenario #3:
A1B3C1A2B4C2A3B1C3A4B2C4

Source

TUD Programming Contest 2005, Darmstadt, Germany


题目链接:http://poj.org/problem?id=2488


题目大意:一个有n*m个格子的棋盘,模拟马走“日”字,求一个棋盘的所有格子能否被走完,如果能,求走的路径,即走格子的先后顺序,如果有多种情况,按字典序最小的情况。用横纵坐标表示格子位置,横坐标是字母,纵坐标是数字。


解题思路:DFS由第一个格子开始搜,因为每步只能走“日”字,所以每步有八个方向,因为按字典序最小的走,枚举方向时也按字典序。找到解的返回过程中标记路径。


代码如下:

#include <cstdio>
#include <cstring>
int dx[8]={-2,-2,-1,-1,1,1,2,2};//按字典序枚举8个方向
int dy[8]={-1,1,-2,2,-2,2,-1,1};
int xx[26]={'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'};
char ansx[28];    //记录横坐标路径
int ansy[28];     //记录纵坐标路径
int sum,m,n,j;
bool p;
int a[28][28],vis[28][28];
void dfs(int x,int y,int cnt)
{
	if(cnt==sum)        //已走完所有格子
	{
		ansx[j]=xx[x];
		ansy[j++]=y+1;
		p=true;
		return;
	}
	for(int i=0;i<8;i++)
	{
		if(x+dx[i]<0||x+dx[i]>=n||y+dy[i]<0||y+dy[i]>=m)
			continue;
		if(vis[x+dx[i]][y+dy[i]])
			continue;
		vis[x+dx[i]][y+dy[i]]=1;
		dfs(x+dx[i],y+dy[i],cnt+1);
		if(p)             //若成功走完格子,往前标记每步路径
		{
			ansx[j]=xx[x];
			ansy[j++]=y+1;
			return;
		}
		vis[x+dx[i]][y+dy[i]]=0;
	}
}
int main()
{
	int t;
	scanf("%d",&t);
	for(int cnt=1;cnt<=t;cnt++)
	{
		p=false,j=0;
		memset(vis,0,sizeof(vis));
		vis[0][0]=1;
		scanf("%d%d",&m,&n);
		sum=n*m;
		dfs(0,0,1);
		printf("Scenario #%d:\n", cnt);
		if(!p)
			printf("impossible\n");
		else     //输出路径
		{
			for(int i=j-1;i>=0;i--)
				printf("%c%d",ansx[i],ansy[i]);
			printf("\n");
		}
		if(cnt<t)
			printf("\n");
	}
	return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值